#pragma once
#include <memory/device.h>

class BootRom : public Mem_device
{
private:
  Mem_device* lowmem;
  Mem_device* highmem;

  Mem_device* backend;

  Range lowrange;
  Range highrange;

  bool enabled;
public:
  BootRom(Mem_device* lowmem, Mem_device* highmem, Mem_device* backend);

  void enable();
  void disable();

  virtual void write8(u16 addr, u8 data);
  virtual u8 read8(u16 addr);

  virtual void write16(u16 addr, u16 data);
  virtual u16 read16(u16 addr);

};
